// gui_mk_tools
// contains code from kr_influence_print
// Kamiryn 21.12.2006

#include "kinc_companion"

const string NAME_AMMON		= "Аммон Джерро";
const string NAME_BISHOP	= "Бишоп";
const string NAME_CASAVIR	= "Касавир";
const string NAME_CONSTRUCT	= "Конструкт";
const string NAME_ELANEE	= "Элани";
const string NAME_GROBNAR	= "Гробнар";
const string NAME_KHELGAR	= "Келгар Айронфист";
const string NAME_NEESHKA	= "Нишка";
const string NAME_QARA		= "Кара";
const string NAME_SAND		= "Сэнд";
const string NAME_SHANDRA	= "Шандра Джерро";
const string NAME_ZHJAEVE	= "Зджаев";
const string NAME_BEVIL		= "Бивил";	// minor companions

string GetCompanionNameByNumber(int nCompanion)
{
	string sCompanionTag = "";

	switch (nCompanion)
	{
		case 1:
			sCompanionTag = NAME_KHELGAR;
			break;
		case 2:
			sCompanionTag = NAME_NEESHKA;
			break;
		case 3:
			sCompanionTag = NAME_ELANEE;
			break;
		case 4:
			sCompanionTag = NAME_QARA;
			break;
		case 5:
			sCompanionTag = NAME_SAND;
			break;
		case 6:
			sCompanionTag = NAME_GROBNAR;
			break;
		case 7:
			sCompanionTag = NAME_CASAVIR;
			break;
		case 8:
			sCompanionTag = NAME_BISHOP;
			break;
		case 9:
			sCompanionTag = NAME_SHANDRA;
			break;
		case 10:
			sCompanionTag = NAME_CONSTRUCT;
			break;
		case 11:
			sCompanionTag = NAME_ZHJAEVE;
			break;
		case 12:
			sCompanionTag = NAME_AMMON;
			break;
		case 13:
			sCompanionTag = NAME_BEVIL;
			break;
		default:
			PrintString("gui_inluence_print-GetCompanionNameByNumber: Invalid companion ID!");
			break;
	}
	return sCompanionTag;
}

void Print(string sString)
{
	SendMessageToPC(GetFirstPC(FALSE), sString);
}

void PrintCompanionInfluence( int nCompID )
{
	string sCompanion = GetCompanionNameByNumber( nCompID );
	int nInfluence = GetInfluenceByNumber( nCompID );
	string sInfluence = IntToString( nInfluence );

	Print(sCompanion + ": " + sInfluence);
}

void PrintInfluence()
{
	Print("<color=cornflowerblue>Информация о влиянии на спутников</color>");
	PrintCompanionInfluence(12);
	PrintCompanionInfluence(13);
	PrintCompanionInfluence(8);
	PrintCompanionInfluence(6);
	PrintCompanionInfluence(11);
	PrintCompanionInfluence(4);
	PrintCompanionInfluence(7);
	PrintCompanionInfluence(1);
	PrintCompanionInfluence(10);
	PrintCompanionInfluence(2);
	PrintCompanionInfluence(5);
	PrintCompanionInfluence(9);
	PrintCompanionInfluence(3);
	Print("********");
}

void PrintAlignment()
{
	int nGoodEvil = GetGoodEvilValue(GetFirstPC(FALSE));
	int nLawChaos = GetLawChaosValue(GetFirstPC(FALSE));

	Print("<color=cornflowerblue>Информация о мировоззрении </color>");
	Print("Добро/Зло = "+IntToString(nGoodEvil)+
		", Хаос/Порядок = "+IntToString(nLawChaos));
	Print("********");
}

void RestoreCompanion(int nCompID)
{
	string sCompanion = GetCompanionTagByNumber( nCompID );
	string sName = GetCompanionNameByNumber(nCompID);
/*	Print(sName+"("+sCompanion+")...");

	if (GetIsRosterMemberSelectable(sCompanion))
		Print("... is selectable");
	if (GetIsRosterMemberAvailable(sCompanion))
		Print("... is available");
*/
	object oCompanion = GetTarget(sCompanion);
/*	if (GetIsObjectValid(oCompanion))
	{
		Print("... GetTarget() is valid");
	}
	else
	{
		oCompanion = GetObjectFromRosterName(sCompanion);
		if (GetIsObjectValid(oCompanion))
		{
			Print("... GetObjectFromRosterName() is valid");
		}
	}
*/
	if (GetIsObjectValid(oCompanion))
	{

//		ChangeToStandardFaction(oCompanion, STANDARD_FACTION_DEFENDER);
//		Print("Setting faction to standard faction defender for "+sName);
		SetCreatureScriptsToSet(oCompanion, 3);
		Print(sName+": Набор скриптов сброшен на вариант по умолчанию – 'Player_Default'(3).");
//		AssignCommand(oCompanion, SetAssociateState(NW_ASC_MODE_STAND_GROUND,FALSE));
	}
}

void BugFixRestoreCompanionsAIScript()
{
	Print("Восстановление скриптов для ИИ спутников...");
	RestoreCompanion(12);
	RestoreCompanion(13);
	RestoreCompanion(8);
	RestoreCompanion(6);
	RestoreCompanion(11);
	RestoreCompanion(4);
	RestoreCompanion(7);
	RestoreCompanion(1);
	RestoreCompanion(10);
	RestoreCompanion(2);
	RestoreCompanion(5);
	RestoreCompanion(9);
	RestoreCompanion(3);
	Print("********");
}

int ExchangeFeats(object oCreature, int nRemoveFeat, int nAddFeat, int bRemoveFeatAlways=TRUE)
{
	int nReturn=0;

	if (GetHasFeat(nAddFeat, oCreature, TRUE))
	{
		nReturn+=1;
	}

	if (!GetHasFeat(nRemoveFeat, oCreature, TRUE))
	{
		nReturn+=2;
	}

	int nStrRef=0;

	if ((nReturn==0) || ((nReturn==1) && bRemoveFeatAlways))
	{
		FeatRemove(oCreature, nRemoveFeat);

		nStrRef = StringToInt(Get2DAString("Feat","Feat",nRemoveFeat));
		if (nStrRef>0)
		{
			Print("Удалённый навык: "+GetStringByStrRef(nStrRef));
		}
	}

	if (nReturn==0)
	{
		FeatAdd(oCreature, nAddFeat, FALSE);

		nStrRef = StringToInt(Get2DAString("Feat","Feat",nAddFeat));
		if (nStrRef>0)
		{
			Print("Добавленный навык: "+GetStringByStrRef(nStrRef));
		}
	}
	return nReturn;
}

void DisplayConstructUpgradeFixMessage(int nReturn, string sUpgrade)
{
	// ExchangeFeats returns
	// 1: has Feat nAddFeat and has Feat nRemoveFeat
	//    -> 'broken' upgrade fix
	// 2: does not have Feat nRemoveFeat and does not have feat nAddFeat
	//    -> no upgrade found
	// 3: has Feat nAddFeat and does not have nRemoveReat
	//    -> upgrade already fixed
	// 0: Feats are exchanged
	//    -> upgrade gets fixed

	switch (nReturn)
	{
	case 0:
		Print(sUpgrade+": Улучшение исправлено.");
		break;
	case 1:
		Print(sUpgrade+": Фикс улучшения исправлен.");
		break;
	case 2:
		Print(sUpgrade+": Улучшение не найдено.");
		break;
	case 3:
		Print(sUpgrade+": Улучшение уже исправлено.");
		break;
	}
}

void BugFixContructUpgrade()
{
	string sConstruct = GetCompanionTagByNumber(10);
	object oConstruct = GetTarget(sConstruct);
	if (!GetIsObjectValid(oConstruct))
	{
		Print("Конструкта нет рядом с вами...");
		return;
	}

	int nReturn=0;

	nReturn = ExchangeFeats(oConstruct, 1786, 1796, TRUE);
	DisplayConstructUpgradeFixMessage(nReturn, "Алхимия");
	if (nReturn==2)
	{
		Print("Этот фикс не исправляет баг с отсутствующим навыком после вмешательстве Сэнда!");
	}

	nReturn = ExchangeFeats(oConstruct, 1787, 1797, TRUE);
	DisplayConstructUpgradeFixMessage(nReturn, "Изготовление доспехов");

	nReturn = ExchangeFeats(oConstruct, 1788, 1798, TRUE);
	DisplayConstructUpgradeFixMessage(nReturn, "Изготовление оружия");
}

void main(int nMode)
{
	switch (nMode)
	{
		case 0:
			PrintInfluence();
			break;
		case 1:
			PrintAlignment();
			break;
		case 2:
			BugFixRestoreCompanionsAIScript();
			break;
		case 3:
			BugFixContructUpgrade();
			break;
	}
}